## REST Service Example

This example demonstrates the implementation of a simple REST service.

### API

The service supports the following HTTP requests:

- `GET /news` - get all news
- `GET /news?keyword={keyword}` - search news by keyword
- `POST /news` - post news
- `DELETE /news/{id}` - delete news

### Features

- The parameter objects are de-/serialized using a Jackson object mapper
- An authentication filter ensures that messages can only be deleted by administrators
- A Postman file with sample requests can be used to manually test the service
- An integration test based on REST Assured can be used for automatic testing
